//##################################################
//# $Id: Main.cpp 8 2005-02-14 09:04:37Z peciva $

/*

   Main.cpp - SpaceGame main file

   Written by Zero (xmaste00) and PCJohn (peciva).


   THIS SOFTWARE IS NOT COPYRIGHTED

   This source code is offered for use in the public domain.
   You may use, modify or distribute it freely.

   This source code is distributed in the hope that it will be useful but
   WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
   DISCLAIMED.  This includes but is not limited to warranties of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

   If you find the source code useful, authors will kindly welcome
   if you give them credit and keep their names with their source code,
   but you are not forced to do so.

*/


#include "Main.h"

#ifdef _MSC_VER
#pragma comment(linker, "/entry:\"mainCRTStartup\"") // Linker will link
               // the application using main(), not WinMain (as usual on Windows).
#pragma comment(linker, "/subsystem:\"CONSOLE\"") // show console
#endif


#if defined(_WIN32) || defined(__WIN32__)
#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/SoWinRenderArea.h>
#include <process.h> // for _getpid()
#define getpid() _getpid()
#else
#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/SoQtRenderArea.h>
#include <unistd.h> // for getpid()
#endif

#include <Inventor/SbTime.h>
#include <Inventor/nodes/SoComplexity.h>
#include <Inventor/nodes/SoFile.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/sensors/SoOneShotSensor.h>
#include <time.h>
/**************************************************/
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoPointLight.h>
#include <windows.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/events/SoKeyboardEvent.h>
#include <Inventor/events/SoMouseButtonEvent.h>
#include <iostream>
#include <string>
#include <map>


using namespace std;

HWND window;
#if defined(__WIN32__) || defined (_WIN32)
  SoWinRenderArea * renderArea;
#else
  SoQtRenderArea * renderArea;
#endif

/**************************************************/

#include "SgObject.h"
#include "SgoManager.h"

static SgoManager *sgoManager;
SgMouse * mouse;
SgKeyboard * keyboard;
SgCamera * kamera;
SoMouseButtonEvent * mouseEvent;
SoKeyboardEvent * keyEvent;

void onMouseButton(void *userdata, SoEventCallback * node){
	const SoEvent * event = node->getEvent();
//	SoMouseButtonEvent::Button butt = mouseEvent->getButton();
	mouse->setButton(event);
	node->setHandled();
}

void onKeyPress(void *userdata, SoEventCallback * node){
	const SoEvent * event = node->getEvent();
//	SoKeyboardEvent::Key k = keyEvent->getKey();
	keyboard->setKey(event);
	node->setHandled();
}

static void timeStep(void *data, SoSensor *sensor)
{
  static SbTime lastTime = SbTime::zero();
  SbTime ct = SbTime::getTimeOfDay();
  SbTime dt;

  if (lastTime == SbTime::zero()) {
    lastTime = ct;
    dt = SbTime::zero();
  } else {
    dt = ct - lastTime;
    lastTime = ct;
  }
  //vyhodnoceni vsech objektu
  sgoManager->timeStep(ct.getValue(), dt.getValue());
  
  if (keyboard->getKey(Cfree)) sgoManager->setActiveFree();
  if (keyboard->getKey(Cfighter)) sgoManager->setActiveFighter();
  if (keyboard->getKey(Crestart)){
	  sgoManager->setActiveFree();
	  sgoManager->getActive()->setPos(0,0,500);
  }

  if (sgoManager->getActive()!=NULL){
	if (keyboard->getKey(Stop)){
		sgoManager->getActive()->setVel(0,0,0);
		sgoManager->getActive()->setAngMom(0,0,0);
	}
/*  // pohyb absolutni (uprava vektoru pozice)
  if (keyboard->getKey(Vpred)) sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()+sgoManager->getActive()->getDirVec()*0.1f);
  if (keyboard->getKey(Vzad))  sgoManager->getActive()->setPos(sgoManager->getActive()->getPos()-sgoManager->getActive()->getDirVec()*0.1f);
*/
  // pohyb relativni (uprava vektoru rychlosti)
  if (keyboard->getKey(Vpred)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()+sgoManager->getActive()->getDirVec()*0.1f);
  if (keyboard->getKey(Vzad))  sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getDirVec()*0.1f);
  if (keyboard->getKey(Left)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getLeftVec()*0.1f);
  if (keyboard->getKey(Right)) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()+sgoManager->getActive()->getLeftVec()*0.1f);
  // vraceni pohybu (zabrzdeni)	    
  if ((!keyboard->getKey(Vpred))&&(!keyboard->getKey(Vzad))){
	  float size=sgoManager->getActive()->getVel().length();
	  if (size>0.1) sgoManager->getActive()->setVel(sgoManager->getActive()->getVel()-sgoManager->getActive()->getDirVel()*0.01f);
	  else sgoManager->getActive()->setVel(0,0,0);
  }
  // otaceni absolutni (uprava orientace)
	// pomoci mysi
  	/*RECT a; 
	POINT p;  
	GetWindowRect(window, &a);
	GetCursorPos(&p);
	sgoManager->getActive()->RotLR((a.left+(a.right-a.left)/2-p.x)/150.f);
	sgoManager->getActive()->RotUD((a.top+(a.bottom-a.top)/2-p.y)/150.f);
  	SetCursorPos(a.left+(a.right-a.left)/2,a.top+(a.bottom-a.top)/2);
  if (keyboard->getKey(RotL)) sgoManager->getActive()->RotAR(0.01f);
  if (keyboard->getKey(RotR)) sgoManager->getActive()->RotAR(-0.01f);*/
/*  if (keyboard->getKey(TurnL)) sgoManager->getActive()->RotLR(0.01f);
  if (keyboard->getKey(TurnR)) sgoManager->getActive()->RotLR(-0.01f);
  if (keyboard->getKey(TurnUp)) sgoManager->getActive()->RotUD(0.01f);
  if (keyboard->getKey(TurnDown)) sgoManager->getActive()->RotUD(-0.01f);*/

  // otaceni relativni (uprava momentu hybnosti)
  if (keyboard->getKey(RotL)) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()-sgoManager->getActive()->getDirVec()*0.01f);
  if (keyboard->getKey(RotR)) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()+sgoManager->getActive()->getDirVec()*0.01f);
  if (keyboard->getKey(TurnL)) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()+sgoManager->getActive()->getUpVec()*0.01f);
  if (keyboard->getKey(TurnR)) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()-sgoManager->getActive()->getUpVec()*0.01f);
  if (keyboard->getKey(TurnUp)) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()+sgoManager->getActive()->getLeftVec()*0.01f);
  if (keyboard->getKey(TurnDown)) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()-sgoManager->getActive()->getLeftVec()*0.01f);
  //vraceni otaceni (zastaveni rotace)
  if ((!keyboard->getKey(RotL))&&(!keyboard->getKey(RotR))&&(!keyboard->getKey(TurnL))&&(!keyboard->getKey(TurnR))
	  &&(!keyboard->getKey(TurnUp))&&(!keyboard->getKey(TurnDown))){
	float size=sgoManager->getActive()->getAngMom().length();
	if (size>0.1) sgoManager->getActive()->setAngMom(sgoManager->getActive()->getAngMom()-sgoManager->getActive()->getAngMom()*0.01f);
	else sgoManager->getActive()->setAngMom(0,0,0);
  }
  }

	  //b->timeStep(ct.getValue(),dt.getValue());

	kamera->setRot(sgoManager->getActive()->getOldOrientation());
	kamera->setPos(sgoManager->getActive()->getPos());
  
	sensor->schedule();
}

int main(int argc, char **argv)
{
  // Inicializace nahodnych cisel
  srand((unsigned int)time(NULL) + getpid());

  // Inventor initialization
#if defined(__WIN32__) || defined (_WIN32)
  window = SoWin::init(argc, argv, argv[0]);
#else
  QWidget* window = SoQt::init(argv[0]);
#endif
  if (window == NULL)  exit(1);

  // Directory with models and textures
  SoInput::addDirectoryFirst("data/textures/");
  SoInput::addDirectoryFirst("data/meshes/");

  // Scene root
  SoSeparator *root = new SoSeparator;
  root->ref();

#if 0
  // When enabled, this will disable texturing.
  // Useful on slower computers.
  SoComplexity *complexity = new SoComplexity;
  complexity->value = 0.f;
  complexity->textureQuality = 0.f;
  root->addChild(complexity);
#endif

	mouse = new SgMouse;
	keyboard = new SgKeyboard;
	mouseEvent = new SoMouseButtonEvent;
	keyEvent = new SoKeyboardEvent;
	
	kamera = new SgCamera;

	root->addChild(kamera->getRoot());

	// Svtla
	SoDirectionalLight *svetlo=new SoDirectionalLight;	//globalni svetlo
	svetlo->direction.setValue(0.0f, 0.0f, -1.0f);
	svetlo->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo->intensity = 0.3;
	root->addChild(svetlo);
	SoPointLight *svetlo1=new SoPointLight;		//svetlo od slunce
	svetlo1->color = SbVec3f(1.0f, 1.0f, 1.0f);
	svetlo1->location = SbVec3f(0,0,0);
	svetlo1->intensity = 1;
	root->addChild(svetlo1);

  // SkyBox
  SoFile *skybox = new SoFile;
  skybox->name = "SkyBox1.iv";
  root->addChild(skybox);


    // SpaceGame Object Manager
	sgoManager = new SgoManager;
	sgoManager->setCamera(kamera->getRoot());
	root->addChild(sgoManager->getSgoRoot());
	SgObject *sgo;

  float Scale=0.9f;
  int count=0;
  float m=1000.0f;	//hmotnost zeme
	
  sgo = new SgObject;		//slunce
  sgo->setType(SgObject::TYPE_OBJECT::SUN);
  sgo->setID(count++);
  sgo->setModel("Sun.wrl", SgObject::RENDER);
  sgo->setPos(0.0f, 0.0f, 0.0f);
  sgo->setSpeed(0.0f, 0.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0,0));
  sgo->setMass(330000*m);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgo->setActionRadius(500*50.f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.06f;				//Merkur
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Merkur.wrl", SgObject::RENDER);
  sgo->setPos(0.f, 67.0f, 0.0f);
  sgo->setSpeed(7.0f, 0.0f, 0.0);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(0.55*m);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.12f;				//Venuse
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Venus.wrl", SgObject::RENDER);
  sgo->setPos(0.0f, -108.2f, 0.0f);
  sgo->setSpeed(6.0f, 0.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(0.81*m);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.2f;				//Zeme
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Earth.wrl", SgObject::RENDER);
  sgo->setPos(0.0f, 149.0f, 0.0f);
  sgo->setSpeed(-5.0f, 0.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(1*m);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.1f;				//Mars
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Mars.wrl", SgObject::RENDER);
  sgo->setPos(0.0f, -272.0f, 0.0f);
  sgo->setSpeed(-3.0f, 0.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(0.11*m);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  /*Scale=0.1f;				//Jupiter
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Jupiter.wrl", SgObject::RENDER);
  sgo->setPos(20.0f, -20.0f, 0.0f);
  sgo->setSpeed(0.0f, 0.0f, -3.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(10000);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.1f;				//Saturn
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Saturn.wrl", SgObject::RENDER);
  sgo->setPos(-20.0f, -20.0f, 0.0f);
  sgo->setSpeed(0.0f, 0.0f, -3.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(10000);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.1f;				//Uran
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Uran.wrl", SgObject::RENDER);
  sgo->setPos(20.0f, 20.0f, 20.0f);
  sgo->setSpeed(0.0f, 0.0f, -3.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(10000);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);

  Scale=0.1f;				//Neptun
  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::PLANET);
  sgo->setID(count++);
  sgo->setModel("Neptun.wrl", SgObject::RENDER);
  sgo->setPos(0.0f, -20.0f, 20.0f);
  sgo->setSpeed(0.0f, 0.0f, -3.0f);
  sgo->setAngMom(SbVec3f(0,0.1,0));
  sgo->setMass(10000);
  sgo->setScale(SbVec3f(1,1,1)*Scale);
  sgo->setCollisionRadius(50*1.2f*Scale);
  sgoManager->appendSgo(sgo);*/

  sgo = new SgObject;	
  sgo->setType(SgObject::TYPE_OBJECT::OTHER);
  sgo->setID(count++);
  sgo->setModel("Bomber.wrl", SgObject::RENDER);
  sgo->setModel("Bomber.wrl", SgObject::COLLISION);
  sgo->setPos(-0.0f, 5.0f, 80.0f);
  sgo->setSpeed(0.0f, -1.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0,0));
  sgo->setMass(1);
  sgo->setCollisionRadius(3);
  sgoManager->appendSgo(sgo);

  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::OTHER);
  sgo->setID(count++);
  sgo->setModel("Bomber.wrl", SgObject::RENDER);
  sgo->setModel("Bomber.wrl", SgObject::COLLISION);
  sgo->setPos(0.0f, 0.0f, 80.0f);
  sgo->setSpeed(0.0f, 0.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0,0));
  sgo->setMass(1);
  sgo->setCollisionRadius(3);
  sgoManager->appendSgo(sgo);

  sgo = new SgObject;
  sgo->setType(SgObject::TYPE_OBJECT::OTHER);
  sgo->setID(count++);
  sgo->setModel("Bomber.wrl", SgObject::RENDER);
  sgo->setModel("Bomber.wrl", SgObject::COLLISION);
  sgo->setPos(0.0f, 0.0f, 100.0f);
  sgo->RotLR(M_PI);
  sgo->setSpeed(0.0f, 0.0f, 0.0f);
  sgo->setAngMom(SbVec3f(0,0,0));
  sgo->setMass(1);
  sgo->setCollisionRadius(3);
  sgoManager->appendSgo(sgo);

  sgoManager->setFighterCamera(count-1);

  sgo = new SgObject;		//prazdny objekt pro kameru
  sgo->setType(SgObject::TYPE_OBJECT::CAMERA);
  sgo->setID(count++);
  sgo->setPos(0.0f, 0.0f, 120.0f);
  sgo->setOrientation(SbVec3f(0,1,0),M_PI);
  sgo->setMass(0);
  sgo->setCollisionRadius(1);
  sgo->setActionRadius(1);
  sgoManager->appendSgo(sgo);
  
  sgoManager->setFreeCamera(count-1);

  sgoManager->setActiveFree();
  
  kamera->setPos(SbVec3f(0,0,180));

 	// Obsluha mysi
	SoEventCallback * cbmouse = new SoEventCallback;
	cbmouse->addEventCallback(SoMouseButtonEvent::getClassTypeId(), onMouseButton, NULL);
	
	root->insertChild(cbmouse, 0);
	// Obsluha klavesnice
	SoEventCallback * cbkeyborad = new SoEventCallback;
	cbkeyborad->addEventCallback(SoKeyboardEvent::getClassTypeId(), onKeyPress, NULL);
	root->insertChild(cbkeyborad, 0);

  SoOneShotSensor *timeStepSensor = new SoOneShotSensor(timeStep, NULL);
  timeStepSensor->schedule();

  // Vytvo renderovac okno
#if defined(__WIN32__) || defined (_WIN32)
  renderArea = new SoWinRenderArea(window);
#else
  renderArea = new SoQtRenderArea(window);
#endif

  // Nastav renderovac okno
	renderArea->setSceneGraph(root);
	renderArea->setTitle("SpaceGame");
	renderArea->show();

	renderArea->getViewportRegion();

  // Zobraz okna a rozje renderovac smyku
#if defined(__WIN32__) || defined (_WIN32)
  SoWin::show(window);
  SoWin::mainLoop();
#else
  SoQt::show(window);
  SoQt::mainLoop();
#endif

  // Uvolni zdroje
#if !defined(NDEBUG)
	delete mouse;
	delete mouseEvent;
	delete keyEvent;
  sgoManager->deteleAllSgos();
  delete sgoManager;
  delete timeStepSensor;
  delete renderArea;
  root->unref();
  SoDB::cleanup();
#endif

  return 0;
}
