#ifndef SG_INTERFACE_H
#define SG_INTERFACE_H
/*

   SgInterface.h - interface class

   Written by Zero (xmaste00).


   THIS SOFTWARE IS NOT COPYRIGHTED

   This source code is offered for use in the public domain.
   You may use, modify or distribute it freely.

   This source code is distributed in the hope that it will be useful but
   WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
   DISCLAIMED.  This includes but is not limited to warranties of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

   If you find the source code useful, authors will kindly welcome
   if you give them credit and keep their names with their source code,
   but you are not forced to do so.

*/

#include "Main.h"

enum t_force{relativeReturn=0, relative=1, absolute=2};
enum t_tlacitko{Mouse1=0,Mouse2=1,Mouse3=2};
enum t_klavesa{Vpred=0, Vzad, RotL, RotR, TurnUp, TurnDown, TurnL, TurnR, Up, Down, Left, Right, Stop, Cfree, Cfighter, Crestart};

class SgMouse{
protected:
	map <t_tlacitko, SoMouseButtonEvent::Button> tlacitko;
	map <t_tlacitko, SoMouseButtonEvent::Button>::iterator Tl;
	map <t_tlacitko, bool> stisknuto;
	map <t_tlacitko, bool>::iterator St;
public:
	SgMouse();

	void setButton (const SoEvent * event);
	bool getButton (t_tlacitko tl);
};

class SgKeyboard{
protected:
	map <t_klavesa, SoKeyboardEvent::Key> klavesa;
	map <t_klavesa, SoKeyboardEvent::Key>::iterator Kl;
	map <t_klavesa, bool> stisknuta;
	map <t_klavesa, bool>::iterator St;

public:
	SgKeyboard();

	void setKey (const SoEvent * event);
	bool getKey (t_klavesa key);
};

class SgCamera{
protected:
	SoPerspectiveCamera * Camera;
	float distance;		//vzdalenost kamery od objektu
	float height;		//vyska kamery od objektu

public:
    SgCamera();
	~SgCamera();
	SoPerspectiveCamera * getRoot(){return Camera;};

	void setRot(SbRotation rot);	//nejprve nastavit rotaci, podle ni se pocita pozice
	void setPos(SbVec3f pos);		//opacne bude skakat kamera
};
#endif /* SG_INTERFAC_H */